SequenceRenderer (BioJava-1.5-beta API)
Keywords: org.biojava.bio.gui.sequence.SequenceRenderer interface

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.biojava.bio.gui.sequence
Interface SequenceRenderer

All Known Implementing Classes:
  AbiTraceRenderer, AbstractPeptideDigestRenderer, AlignmentRenderer, BumpedRenderer, FeatureBlockSequenceRenderer, FilteringRenderer, GappedRenderer, GlyphFeatureRenderer, LabelledSequenceRenderer, MultiLineRenderer, OffsetRulerRenderer, OverlayRendererWrapper, PaddingRenderer, PeptideDigestRenderer, RulerRenderer, SecondaryStructureFeatureRenderer, SequenceRendererWrapper, SixFrameRenderer, StopRenderer, SymbolSequenceRenderer

    public interface SequenceRenderer

The interface for things that can render a line of information about a sequence.

Renderers are always activated within the context of a particular sequence panel. A single Renderer can be shared among many sequence panels, or added multiple times to the same panel. The renderer is required to request how much leading and trailing space it requires, as well as the depth (space orthogonal to the direction in which the sequence is rendered).

The leading and trailing distances are the number of pixels overhang needed to cleanly render any line of sequence information. For example, a ruler will need trailing space to render the total sequence length at the end.

Author:
  Thomas Down, Matthew Pocock, Keith James

Nested Class Summary
`static class` | `SequenceRenderer.RendererForwarder`

Method Summary
`double` | `getDepth(SequenceRenderContext src)` Retrieve the depth of this renderer when rendering src.
`double` | `getMinimumLeader(SequenceRenderContext src)` Retrieve the minimum leading distance for this renderer when rendering src.
`double` | `getMinimumTrailer(SequenceRenderContext src)` Retrieve the minimum trailing distance for this renderer when rendering src.
`void` | `paint(Graphics2D g, SequenceRenderContext src)` Render a portion (possibly all) of the information for src to g, displaying all of the data that would fall within seqBox.
`SequenceViewerEvent` | `processMouseEvent(SequenceRenderContext src, MouseEvent me, List path)` Produce a SequenceViewerEvent in response to a mouse gesture.

Method Detail

### paint

    void paint(Graphics2D g,
               SequenceRenderContext src)

  Render a portion (possibly all) of the information for src to g, displaying all of the data that would fall within seqBox.

  Parameters:
    `g` - the Graphics2D to render to
    `src` - the SequenceRenderContext that encapsulates the information to render

### getDepth

    double getDepth(SequenceRenderContext src)

  Retrieve the depth of this renderer when rendering src.

  The depth may vary between sequence panels - for example based upon sequence length. Each line of information in the SequenceRendererContext only renders a region of the sequence. The depth for one complete line may be different from that for another due to the sequence having more or less information in that region to show. For example, a feature renderer implementation may chose to collapse down to a depth of zero pixels if there are no features to render within a region.

  Parameters:
    `src` - the SequenceRenderContext to return info for
  Returns:
    the depth of the renderer for that sequence panel

### getMinimumLeader

    double getMinimumLeader(SequenceRenderContext src)

  Retrieve the minimum leading distance for this renderer when rendering src.

  The leading distance may vary between sequence panels - for example based upon sequence length.

  Parameters:
    `src` - the SequenceRenderContext to return info for
  Returns:
    the leading distance of the renderer for that sequence panel

### getMinimumTrailer

    double getMinimumTrailer(SequenceRenderContext src)

  Retrieve the minimum trailing distance for this renderer when rendering src.

  The trailing distance may vary between sequence panels - for example based upon sequence length.

  Parameters:
    `src` - the SequenceRenderContext to return info for
  Returns:
    the trailing distance of the renderer for that sequence panel

### processMouseEvent

    SequenceViewerEvent processMouseEvent(SequenceRenderContext src,
                                          MouseEvent me,
                                          List path)

  Produce a SequenceViewerEvent in response to a mouse gesture.

  A SequenceRenderer that performs any form of coordinate remapping should ensure that it appropriately transforms the mouse event. However, in the SequenceViewerEvent returned, the MouseEvent should be in untransformed coordinates.

  The SequenceRenderer implementation should append itself to the path list before constructing the SequenceViewerEvent.

  Parameters:
    `src` - the SequenceRenderContext currently in scope
    `me` - a MouseEvent that caused this request
    `path` - the List of SequenceRenderer instances passed through so far
  Returns:
    a SequenceViewerEvent encapsulating the mouse gesture
  Since:
    1.2

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD